/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

/* Box model */

.rubiks-loader {
  height: 130px;
  perspective: 130px;
  position: relative;
  width: 130px;

  *,
  *::before,
  *::after {
    box-sizing: border-box;
  }

  .cube {
    display: inline-block;
    font-size: 0;
    height: 100%;
    transform-style: preserve-3d;
    width: 100%;

    .piece {
      animation-duration: 1.5s;
      animation-iteration-count: infinite;
      backface-visibility: hidden;
      display: inline-block;
      height: 30px;
      position: absolute;
      width: 30px;

      &.row-top {
        top: 10px;
      }

      &.row-center {
        top: 50px;
      }

      &.row-bottom {
        top: 90px;
      }

      &.col-left {
        left: 10px;
      }

      &.col-center {
        left: 50px;
      }

      &.col-right {
        left: 90px;
      }

      &.col-left.row-top {
        transform-origin: 55px 55px -55px;
      }

      &.col-center.row-top {
        transform-origin: 15px 55px -55px;
      }

      &.col-right.row-top {
        transform-origin: -25px 55px -55px;
      }

      &.col-left.row-center {
        transform-origin: 55px 15px -55px;
      }

      &.col-center.row-center {
        transform-origin: 15px 15px -55px;
      }

      &.col-right.row-center {
        transform-origin: -25px 15px -55px;
      }

      &.col-left.row-bottom {
        transform-origin: 55px -25px -55px;
      }

      &.col-center.row-bottom {
        transform-origin: 15px -25px -55px;
      }

      &.col-right.row-bottom {
        transform-origin: -25px -25px -55px;
      }

      &.yellow {
        background-color: #f6c574;
      }

      &.blue {
        background-color: #00aacf;
      }

      &.green {
        background-color: #00b3a0;
      }

      &.white {
        background-color: #e2e8e7;
      }

      &.red {
        background-color: #fc5652;
      }

      &.orange {
        background-color: #fc9f39;
      }
    }

    .face.back {
      transform: rotateY(180deg);
    }

    .face.right {
      transform: rotateY(90deg);
    }

    .face.left {
      transform: rotateY(-90deg);
    }

    .face.up {
      transform: rotateX(90deg);
    }

    .face.down {
      transform: rotateX(-90deg);
    }
  }

  .face.piece.front.row-center.col-left,
  .face.piece.down.row-center.col-center,
  .face.piece.front.row-center.col-right {
    animation-name: step-2-front-to-left;
  }

  .face.front.piece.col-center {
    animation-name: step-1-front-to-up;
  }

  .face.down.piece.col-center {
    animation-name: step-1-down-to-front;
  }

  .face.right.piece.row-center {
    animation-name: step-2-right-to-front;
  }

  .face.piece.front.row-top.col-left,
  .face.piece.front.row-bottom.col-left {
    animation-name: step-3-front-to-down;
  }
  
  .face.piece.right.row-center.col-left {
    animation-name: step-2-3-right-to-front-to-down;
  }

  .face.up.piece.col-left {
    animation-name: step-3-up-to-front;
  }
  
  .face.piece.front.row-bottom.col-right {
    animation-name: step-4-front-to-right;
  }

  .face.piece.down.row-bottom.col-center {
    animation-name: step-1-4-down-to-front-to-right;
  }

  .face.piece.up.row-bottom.col-left {
    animation-name: step-3-4-up-to-front-to-right;
  }

  .face.left.piece.row-bottom {
    animation-name: step-4-left-to-front;
  }

}

@keyframes step-1-front-to-up {
  0% {
    transform: rotateX(0deg);
  }

  25%,
  100% {
    transform: rotateX(90deg);
  }
}

@keyframes step-1-down-to-front {
  0% {
    transform: rotateX(-90deg);
  }

  25%,
  100% {
    transform: rotateX(0deg);
  }
}

@keyframes step-2-front-to-left {
  25% {
    transform: rotateY(0deg);
  }

  50%,
  100% {
    transform: rotateY(-90deg);
  }
}

@keyframes step-2-right-to-front {
  25% {
    transform: rotateY(90deg);
  }

  50%,
  100% {
    transform: rotateY(0deg);
  }
}

@keyframes step-3-front-to-down {
  50% {
    transform: rotateX(0deg);
  }

  75%,
  100% {
    transform: rotateX(-90deg);
  }
}

@keyframes step-2-3-right-to-front-to-down {
  25% {
    transform: rotateY(90deg);
  }

  50% {
    transform: rotateX(0deg);
  }

  75%,
  100% {
    transform: rotateX(-90deg);
  }
}

@keyframes step-3-up-to-front {
  50% {
    transform: rotateX(90deg);
  }

  75%,
  100% {
    transform: rotateX(0deg);
  }
}

@keyframes step-4-front-to-right {
  75% {
    transform: rotateY(0deg);
  }

  100% {
    transform: rotateY(90deg);
  }
}

@keyframes step-1-4-down-to-front-to-right {
  0% {
    transform: rotateX(-90deg);
  }

  25% {
    transform: rotateX(0deg);
  }

  75% {
    transform: rotateY(0deg);
  }

  100% {
    transform: rotateY(90deg);
  }
}

@keyframes step-3-4-up-to-front-to-right {
  50% {
    transform: rotateX(90deg);
  }

  75% {
    transform: rotateY(0deg);
  }

  100% {
    transform: rotateY(90deg);
  }
}

@keyframes step-4-left-to-front {
  75% {
    transform: rotateY(-90deg);
  }

  100% {
    transform: rotateY(0deg);
  }
}
